
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.geom.*;


public class Output {
    FileOutputStream FS;
    String S;

    public Output(String S) {
	this.S=S;
	try {FS=new FileOutputStream(S);}
	catch(IOException e) {}
    }

    public void write(String S) {
	PrintStream PS=new PrintStream(FS);
	PS.print(S);
    }

    public void writeln(String S) {
	PrintStream PS=new PrintStream(FS);
	PS.println(S);
    }

    public void writeSTL(Polyhedron P,int current,boolean singleton) {
            Integer FNUM=new Integer(current);

	    if(singleton==true) writeln("solid piece"+FNUM.toString());
	        int num=P.facet[0][0];
		for(int i=1;i<num+1;++i) {
                    int facenum=P.facet[i][0];
		    for(int j=0;j<facenum-2;++j) {
			Vector V1=P.V[P.facet[i][1+j]];
			Vector V2=P.V[P.facet[i][2+j]];
			Vector V3=P.V[P.facet[i][3+j]];
			Vector V12=Vector.minus(V1,V2);
			Vector V13=Vector.minus(V1,V3);
			Vector N=Vector.cross(V12,V13);
			write("facet normal ");
			write(N);
			writeln("");
			writeln("outer loop");
			write("vertex ");
			write(V1);
			writeln("");
			write("vertex ");
			write(V2);
			writeln("");
			write("vertex ");
			write(V3);
			writeln("");
			writeln("endloop");
			writeln("endfacet");
		    }
		}
		if(singleton==true) writeln("endsolid");
    }





    public void writeOBJ(Polyhedron P,int listnum) {

	Integer K=new Integer(listnum+1);
	writeln("#################################");
	writeln("o "+K.toString());
	writeln("");

	writeln("# Vertex list");
	writeln("");

	for(int i=0;i<P.length;++i) {
	    write("v ");
	    write(P.V[i]);
	    writeln("");
	}

	writeln("");
	writeln("# Face list");
	writeln("");
	writeln("usemtl Default");
        
	int num=P.facet[0][0];
	for(int i=1;i<num+1;++i) {
	       int facenum=P.facet[i][0];
	       write("f ");
	       for(int j=1;j<facenum+1;++j) {
		   int k=P.facet[i][j];
		   K=new Integer(k+1);
		   write(K.toString()+" ");
	       }
	       writeln("");
	   }
	writeln("#################################");
	writeln("");
    }

    public void write(Vector V) {
	for(int i=0;i<3;++i) {
	    Double D=new Double(V.x[i]);
	    write(D.toString()+" ");
	}
    }

}

